<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::libcurlUtils Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html">libcurlUtils</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::libcurlUtils Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_callback_data.html">CallbackData</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_curl_easy_handle_wrapper.html">CurlEasyHandleWrapper</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_curl_multi_handle_wrapper.html">CurlMultiHandleWrapper</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_content_fetcher_factory.html">HTTPContentFetcherFactory</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post.html">HttpPost</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">LIBCURL based implementation of <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html" title="Minimal interface for making Http POST requests. ">HttpPostInterface</a>.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html">HttpPostInterface</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Minimal interface for making Http POST requests.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_post_interface.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_put.html">HttpPut</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">LIBCURL based implementation of <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_put_interface.html" title="Minimal interface for making HTTP PUT requests. ">HttpPutInterface</a>.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_put.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_put_interface.html">HttpPutInterface</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Minimal interface for making HTTP PUT requests.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_http_put_interface.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_h_t_t_p_response.html">HTTPResponse</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_libcurl_h_t_t_p2_connection.html">LibcurlHTTP2Connection</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_libcurl_h_t_t_p2_connection_factory.html">LibcurlHTTP2ConnectionFactory</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_libcurl_h_t_t_p2_request.html">LibcurlHTTP2Request</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils_1_1_lib_curl_http_content_fetcher.html">LibCurlHttpContentFetcher</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ae20c6835cf1bb6f0a644fab384c33126"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#ae20c6835cf1bb6f0a644fab384c33126">prepareForTLS</a> (CURL *handle)</td></tr>
<tr class="separator:ae20c6835cf1bb6f0a644fab384c33126"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12cbf33344a8ab199d28126044c0b029"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a12cbf33344a8ab199d28126044c0b029">TAG</a> (&quot;CallbackData&quot;)</td></tr>
<tr class="memdesc:a12cbf33344a8ab199d28126044c0b029"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#a12cbf33344a8ab199d28126044c0b029">More...</a><br /></td></tr>
<tr class="separator:a12cbf33344a8ab199d28126044c0b029"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8106ecee101a6284f7fc0f3f6ed8a11"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#ad8106ecee101a6284f7fc0f3f6ed8a11">TAG</a> (&quot;CurlEasyHandleWrapper&quot;)</td></tr>
<tr class="memdesc:ad8106ecee101a6284f7fc0f3f6ed8a11"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#ad8106ecee101a6284f7fc0f3f6ed8a11">More...</a><br /></td></tr>
<tr class="separator:ad8106ecee101a6284f7fc0f3f6ed8a11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca0d4c28b744911d769a0b7e0f17446f"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aca0d4c28b744911d769a0b7e0f17446f">TAG</a> (&quot;CurlMultiHandleWrapper&quot;)</td></tr>
<tr class="memdesc:aca0d4c28b744911d769a0b7e0f17446f"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#aca0d4c28b744911d769a0b7e0f17446f">More...</a><br /></td></tr>
<tr class="separator:aca0d4c28b744911d769a0b7e0f17446f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f8fdffe41a3bd41fce854ebdedd2a65"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a2f8fdffe41a3bd41fce854ebdedd2a65">TAG</a> (&quot;HTTPContentFetcherFactory&quot;)</td></tr>
<tr class="memdesc:a2f8fdffe41a3bd41fce854ebdedd2a65"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#a2f8fdffe41a3bd41fce854ebdedd2a65">More...</a><br /></td></tr>
<tr class="separator:a2f8fdffe41a3bd41fce854ebdedd2a65"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef6b66ee97f91a2a4637237487469a10"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aef6b66ee97f91a2a4637237487469a10">TAG</a> (&quot;HttpPost&quot;)</td></tr>
<tr class="memdesc:aef6b66ee97f91a2a4637237487469a10"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#aef6b66ee97f91a2a4637237487469a10">More...</a><br /></td></tr>
<tr class="separator:aef6b66ee97f91a2a4637237487469a10"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b8ba50cb8bb66716e032cc3aafafbc6"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a3b8ba50cb8bb66716e032cc3aafafbc6">TAG</a> (&quot;HttpPut&quot;)</td></tr>
<tr class="memdesc:a3b8ba50cb8bb66716e032cc3aafafbc6"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#a3b8ba50cb8bb66716e032cc3aafafbc6">More...</a><br /></td></tr>
<tr class="separator:a3b8ba50cb8bb66716e032cc3aafafbc6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90c60e70a571a71b639e92bfbb2034c9"><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a90c60e70a571a71b639e92bfbb2034c9">readCallback</a> (char *dataBuffer, size_t blockSize, size_t numBlocks, void *dataStream)</td></tr>
<tr class="separator:a90c60e70a571a71b639e92bfbb2034c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a39b52087d31b2bee046af1dfd9a27db0"><td class="memItemLeft" align="right" valign="top">static size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a39b52087d31b2bee046af1dfd9a27db0">writeCallback</a> (char *dataBuffer, size_t blockSize, size_t numBlocks, void *dataStream)</td></tr>
<tr class="separator:a39b52087d31b2bee046af1dfd9a27db0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5105a7c7c50d2f069944ae6e79c9e007"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a5105a7c7c50d2f069944ae6e79c9e007">TAG</a> (&quot;LibcurlHTTP2Connection&quot;)</td></tr>
<tr class="memdesc:a5105a7c7c50d2f069944ae6e79c9e007"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#a5105a7c7c50d2f069944ae6e79c9e007">More...</a><br /></td></tr>
<tr class="separator:a5105a7c7c50d2f069944ae6e79c9e007"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa278a197e87deca298650f15a12cedc"><td class="memItemLeft" align="right" valign="top">static const std::chrono::milliseconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aaa278a197e87deca298650f15a12cedc">WAIT_FOR_ACTIVITY_TIMEOUT</a> (100)</td></tr>
<tr class="memdesc:aaa278a197e87deca298650f15a12cedc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout for curl_multi_wait.  <a href="#aaa278a197e87deca298650f15a12cedc">More...</a><br /></td></tr>
<tr class="separator:aaa278a197e87deca298650f15a12cedc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb9fdea8054ecd291e91e1787188ed1a"><td class="memItemLeft" align="right" valign="top">static const std::chrono::milliseconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#abb9fdea8054ecd291e91e1787188ed1a">WAIT_FOR_ACTIVITY_WHILE_STREAMS_PAUSED_TIMEOUT</a> (10)</td></tr>
<tr class="memdesc:abb9fdea8054ecd291e91e1787188ed1a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout for curl_multi_wait while all non-intermittent HTTP/2 streams are paused.  <a href="#abb9fdea8054ecd291e91e1787188ed1a">More...</a><br /></td></tr>
<tr class="separator:abb9fdea8054ecd291e91e1787188ed1a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3918e30f6e97b9a734e575539ff6ffb7"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a3918e30f6e97b9a734e575539ff6ffb7">performCurlChecks</a> ()</td></tr>
<tr class="separator:a3918e30f6e97b9a734e575539ff6ffb7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe90cb5e643bc9f95281a4baccd9e7ee"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#afe90cb5e643bc9f95281a4baccd9e7ee">TAG</a> (&quot;LibcurlHTTP2ConnectionFactory&quot;)</td></tr>
<tr class="memdesc:afe90cb5e643bc9f95281a4baccd9e7ee"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#afe90cb5e643bc9f95281a4baccd9e7ee">More...</a><br /></td></tr>
<tr class="separator:afe90cb5e643bc9f95281a4baccd9e7ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac6c329873a88a6d4f1fcc99de0966f81"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#ac6c329873a88a6d4f1fcc99de0966f81">TAG</a> (&quot;LibcurlHTTP2Request&quot;)</td></tr>
<tr class="memdesc:ac6c329873a88a6d4f1fcc99de0966f81"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#ac6c329873a88a6d4f1fcc99de0966f81">More...</a><br /></td></tr>
<tr class="separator:ac6c329873a88a6d4f1fcc99de0966f81"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3edac8fd6ed5516bac879dfbcd8217c2"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a3edac8fd6ed5516bac879dfbcd8217c2">TAG</a> (&quot;LibCurlHttpContentFetcher&quot;)</td></tr>
<tr class="memdesc:a3edac8fd6ed5516bac879dfbcd8217c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#a3edac8fd6ed5516bac879dfbcd8217c2">More...</a><br /></td></tr>
<tr class="separator:a3edac8fd6ed5516bac879dfbcd8217c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada2ad07991f4fbc9f659496ea4136ecd"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#ada2ad07991f4fbc9f659496ea4136ecd">TAG</a> (&quot;LibcurlUtils&quot;)</td></tr>
<tr class="memdesc:ada2ad07991f4fbc9f659496ea4136ecd"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#ada2ad07991f4fbc9f659496ea4136ecd">More...</a><br /></td></tr>
<tr class="separator:ada2ad07991f4fbc9f659496ea4136ecd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a489668649c011f1fde0039b6d0efa695"><td class="memTemplParams" colspan="2">template&lt;typename ValueType &gt; </td></tr>
<tr class="memitem:a489668649c011f1fde0039b6d0efa695"><td class="memTemplItemLeft" align="right" valign="top">static bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a489668649c011f1fde0039b6d0efa695">setopt</a> (CURL *handle, CURLoption option, ValueType value, const char *optionName, const char *valueAsString)</td></tr>
<tr class="separator:a489668649c011f1fde0039b6d0efa695"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a7fbbe720b79720306074ac8acb274883"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a7fbbe720b79720306074ac8acb274883">JSON_MIME_TYPE</a> = &quot;application/json&quot;</td></tr>
<tr class="memdesc:a7fbbe720b79720306074ac8acb274883"><td class="mdescLeft">&#160;</td><td class="mdescRight">MIME Content-Type for JSON data.  <a href="#a7fbbe720b79720306074ac8acb274883">More...</a><br /></td></tr>
<tr class="separator:a7fbbe720b79720306074ac8acb274883"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac61ca68afbad2308882b6206dfa1cb9b"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#ac61ca68afbad2308882b6206dfa1cb9b">OCTET_MIME_TYPE</a> = &quot;application/octet-stream&quot;</td></tr>
<tr class="memdesc:ac61ca68afbad2308882b6206dfa1cb9b"><td class="mdescLeft">&#160;</td><td class="mdescRight">MIME Content-Type for octet stream data.  <a href="#ac61ca68afbad2308882b6206dfa1cb9b">More...</a><br /></td></tr>
<tr class="separator:ac61ca68afbad2308882b6206dfa1cb9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08b1ec8716b9c61f15790c03308a0d9c"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a08b1ec8716b9c61f15790c03308a0d9c">LIBCURLUTILS_CONFIG_KEY</a> = &quot;libcurlUtils&quot;</td></tr>
<tr class="memdesc:a08b1ec8716b9c61f15790c03308a0d9c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Key for looking up the <code>LibCurlUtil</code> <code>ConfigurationNode</code>.  <a href="#a08b1ec8716b9c61f15790c03308a0d9c">More...</a><br /></td></tr>
<tr class="separator:a08b1ec8716b9c61f15790c03308a0d9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a809c291805fb165e687d4f65a3b922d6"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a809c291805fb165e687d4f65a3b922d6">INTERFACE_CONFIG_KEY</a> = &quot;CURLOPT_INTERFACE&quot;</td></tr>
<tr class="memdesc:a809c291805fb165e687d4f65a3b922d6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Key for looking up a configuration value for <code>CURLOPT_INTERFACE</code>.  <a href="#a809c291805fb165e687d4f65a3b922d6">More...</a><br /></td></tr>
<tr class="separator:a809c291805fb165e687d4f65a3b922d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8232ee401bb034d90e92f628ce333cf3"><td class="memItemLeft" align="right" valign="top">static constexpr long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a8232ee401bb034d90e92f628ce333cf3">INVALID_RESPONSE_CODE</a> = -1L</td></tr>
<tr class="separator:a8232ee401bb034d90e92f628ce333cf3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a582c6c6e07d6472ad6164f369bfc5745"><td class="memItemLeft" align="right" valign="top">static const std::chrono::milliseconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a582c6c6e07d6472ad6164f369bfc5745">TIMEOUT_FOR_BLOCKING_WRITE</a> = std::chrono::milliseconds(100)</td></tr>
<tr class="separator:a582c6c6e07d6472ad6164f369bfc5745"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae322c113e9b928d6af66474f5a281e2"><td class="memItemLeft" align="right" valign="top">static const std::chrono::milliseconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aae322c113e9b928d6af66474f5a281e2">WAIT_FOR_ACTIVITY_TIMEOUT</a> {100}</td></tr>
<tr class="memdesc:aae322c113e9b928d6af66474f5a281e2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout for polling loops that check activities running on separate threads.  <a href="#aae322c113e9b928d6af66474f5a281e2">More...</a><br /></td></tr>
<tr class="separator:aae322c113e9b928d6af66474f5a281e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec2416d5a1025b96be723531fb5d92e8"><td class="memItemLeft" align="right" valign="top">static const auto&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aec2416d5a1025b96be723531fb5d92e8">TIMEOUT_CONNECTION</a> = std::chrono::seconds(30)</td></tr>
<tr class="memdesc:aec2416d5a1025b96be723531fb5d92e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout for curl connection.  <a href="#aec2416d5a1025b96be723531fb5d92e8">More...</a><br /></td></tr>
<tr class="separator:aec2416d5a1025b96be723531fb5d92e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ca3604189ed467fad1ee766125257b3"><td class="memItemLeft" align="right" valign="top">static const std::chrono::minutes&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a3ca3604189ed467fad1ee766125257b3">MAX_GET_BODY_WAIT</a> {1}</td></tr>
<tr class="memdesc:a3ca3604189ed467fad1ee766125257b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout to wait for a call to get body after getContent was called.  <a href="#a3ca3604189ed467fad1ee766125257b3">More...</a><br /></td></tr>
<tr class="separator:a3ca3604189ed467fad1ee766125257b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa144178293557a48cec87fd8a1eecfb1"><td class="memItemLeft" align="right" valign="top">static const std::chrono::minutes&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#aa144178293557a48cec87fd8a1eecfb1">MAX_GET_HEADER_WAIT</a> {5}</td></tr>
<tr class="memdesc:aa144178293557a48cec87fd8a1eecfb1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout to wait for get header to complete.  <a href="#aa144178293557a48cec87fd8a1eecfb1">More...</a><br /></td></tr>
<tr class="separator:aa144178293557a48cec87fd8a1eecfb1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08b1ec8716b9c61f15790c03308a0d9c"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a08b1ec8716b9c61f15790c03308a0d9c">LIBCURLUTILS_CONFIG_KEY</a> = &quot;libcurlUtils&quot;</td></tr>
<tr class="memdesc:a08b1ec8716b9c61f15790c03308a0d9c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Key for looking up the <code>LibCurlUtil</code> <code>ConfigurationNode</code>.  <a href="#a08b1ec8716b9c61f15790c03308a0d9c">More...</a><br /></td></tr>
<tr class="separator:a08b1ec8716b9c61f15790c03308a0d9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c02f4058583acb4f014ed8dcf1bec08"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a8c02f4058583acb4f014ed8dcf1bec08">CAPATH_CONFIG_KEY</a> = &quot;CURLOPT_CAPATH&quot;</td></tr>
<tr class="memdesc:a8c02f4058583acb4f014ed8dcf1bec08"><td class="mdescLeft">&#160;</td><td class="mdescRight">Key for looking up a configuration value for <code>CURLOPT_CAPATH</code>.  <a href="#a8c02f4058583acb4f014ed8dcf1bec08">More...</a><br /></td></tr>
<tr class="separator:a8c02f4058583acb4f014ed8dcf1bec08"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b622fcccbae1b42feafde78346af7d2"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1libcurl_utils.html#a5b622fcccbae1b42feafde78346af7d2">VERIFY_HOSTS_AND_PEERS_CONFIG_KEY</a> = &quot;verifyHostsAndPeers&quot;</td></tr>
<tr class="memdesc:a5b622fcccbae1b42feafde78346af7d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Key for looking up a configuration value for verifying hosts and peers.  <a href="#a5b622fcccbae1b42feafde78346af7d2">More...</a><br /></td></tr>
<tr class="separator:a5b622fcccbae1b42feafde78346af7d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="a3918e30f6e97b9a734e575539ff6ffb7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3918e30f6e97b9a734e575539ff6ffb7">&#9670;&nbsp;</a></span>performCurlChecks()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static bool alexaClientSDK::avsCommon::utils::libcurlUtils::performCurlChecks </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This function logs a warning if the version of curl is not recent enough for use with the ACL. </p><dl class="section return"><dt>Returns</dt><dd>true if check passes, false if it fails </dd></dl>

</div>
</div>
<a id="ae20c6835cf1bb6f0a644fab384c33126"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae20c6835cf1bb6f0a644fab384c33126">&#9670;&nbsp;</a></span>prepareForTLS()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::libcurlUtils::prepareForTLS </td>
          <td>(</td>
          <td class="paramtype">CURL *&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Prepare a CURL handle to require TLS based upon global configuration settings.</p>
<p class="">The 'libCurlUtils' sub-component of the global configuration supports the following options:</p><ul>
<li>CURLOPT_CAPATH If present, specifies a value for the libcurl property CURLOPT_CAPATH.</li>
</ul>
<p class="">Here is an example configuration: </p><div class="fragment"><div class="line">{</div><div class="line">    <span class="stringliteral">&quot;libcurlUtils&quot;</span> : {</div><div class="line">        <span class="stringliteral">&quot;CURLOPT_CAPATH&quot;</span> : <span class="stringliteral">&quot;/path/to/directory/with/ca/certificates&quot;</span></div><div class="line">    }</div><div class="line">    <span class="comment">// Other configuration nodes</span></div><div class="line">}</div></div><!-- fragment --><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">handle</td><td>The libcurl handle to prepare. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the operation was successful. </dd></dl>

</div>
</div>
<a id="a90c60e70a571a71b639e92bfbb2034c9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a90c60e70a571a71b639e92bfbb2034c9">&#9670;&nbsp;</a></span>readCallback()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">size_t alexaClientSDK::avsCommon::utils::libcurlUtils::readCallback </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>dataBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>blockSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numBlocks</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>dataStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Read callback function used for CURLOPT_READFUNCTION option in libcurl </p>

</div>
</div>
<a id="a489668649c011f1fde0039b6d0efa695"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a489668649c011f1fde0039b6d0efa695">&#9670;&nbsp;</a></span>setopt()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ValueType &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static bool alexaClientSDK::avsCommon::utils::libcurlUtils::setopt </td>
          <td>(</td>
          <td class="paramtype">CURL *&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">CURLoption&#160;</td>
          <td class="paramname"><em>option</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ValueType&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>optionName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>valueAsString</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Set an <code>option</code> on a <code>libcurl</code> handle to <code>value</code>.</p>
<dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">ValueType</td><td>The type of value being set </td></tr>
  </table>
  </dd>
</dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">handle</td><td>The CURL handle to set the option on. </td></tr>
    <tr><td class="paramname">option</td><td>The option to set. </td></tr>
    <tr><td class="paramname">value</td><td>The new value for the specified option. </td></tr>
    <tr><td class="paramname">optionName</td><td>The name of the option being set. </td></tr>
    <tr><td class="paramname">valueAsString</td><td>String representation of the value being set. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the option was set. </dd></dl>

</div>
</div>
<a id="aca0d4c28b744911d769a0b7e0f17446f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aca0d4c28b744911d769a0b7e0f17446f">&#9670;&nbsp;</a></span>TAG() <span class="overload">[1/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;CurlMultiHandleWrapper&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="a2f8fdffe41a3bd41fce854ebdedd2a65"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2f8fdffe41a3bd41fce854ebdedd2a65">&#9670;&nbsp;</a></span>TAG() <span class="overload">[2/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;HTTPContentFetcherFactory&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="afe90cb5e643bc9f95281a4baccd9e7ee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe90cb5e643bc9f95281a4baccd9e7ee">&#9670;&nbsp;</a></span>TAG() <span class="overload">[3/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;LibcurlHTTP2ConnectionFactory&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="ada2ad07991f4fbc9f659496ea4136ecd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada2ad07991f4fbc9f659496ea4136ecd">&#9670;&nbsp;</a></span>TAG() <span class="overload">[4/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;LibcurlUtils&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="aef6b66ee97f91a2a4637237487469a10"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aef6b66ee97f91a2a4637237487469a10">&#9670;&nbsp;</a></span>TAG() <span class="overload">[5/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;HttpPost&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="ac6c329873a88a6d4f1fcc99de0966f81"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac6c329873a88a6d4f1fcc99de0966f81">&#9670;&nbsp;</a></span>TAG() <span class="overload">[6/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;LibcurlHTTP2Request&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="a12cbf33344a8ab199d28126044c0b029"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a12cbf33344a8ab199d28126044c0b029">&#9670;&nbsp;</a></span>TAG() <span class="overload">[7/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;CallbackData&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="a5105a7c7c50d2f069944ae6e79c9e007"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5105a7c7c50d2f069944ae6e79c9e007">&#9670;&nbsp;</a></span>TAG() <span class="overload">[8/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;LibcurlHTTP2Connection&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="a3b8ba50cb8bb66716e032cc3aafafbc6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3b8ba50cb8bb66716e032cc3aafafbc6">&#9670;&nbsp;</a></span>TAG() <span class="overload">[9/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;HttpPut&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="a3edac8fd6ed5516bac879dfbcd8217c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3edac8fd6ed5516bac879dfbcd8217c2">&#9670;&nbsp;</a></span>TAG() <span class="overload">[10/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;LibCurlHttpContentFetcher&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="ad8106ecee101a6284f7fc0f3f6ed8a11"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8106ecee101a6284f7fc0f3f6ed8a11">&#9670;&nbsp;</a></span>TAG() <span class="overload">[11/11]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;CurlEasyHandleWrapper&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
<a id="aaa278a197e87deca298650f15a12cedc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaa278a197e87deca298650f15a12cedc">&#9670;&nbsp;</a></span>WAIT_FOR_ACTIVITY_TIMEOUT()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::chrono::milliseconds alexaClientSDK::avsCommon::utils::libcurlUtils::WAIT_FOR_ACTIVITY_TIMEOUT </td>
          <td>(</td>
          <td class="paramtype">100&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Timeout for curl_multi_wait. </p>

</div>
</div>
<a id="abb9fdea8054ecd291e91e1787188ed1a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abb9fdea8054ecd291e91e1787188ed1a">&#9670;&nbsp;</a></span>WAIT_FOR_ACTIVITY_WHILE_STREAMS_PAUSED_TIMEOUT()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::chrono::milliseconds alexaClientSDK::avsCommon::utils::libcurlUtils::WAIT_FOR_ACTIVITY_WHILE_STREAMS_PAUSED_TIMEOUT </td>
          <td>(</td>
          <td class="paramtype">10&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Timeout for curl_multi_wait while all non-intermittent HTTP/2 streams are paused. </p>

</div>
</div>
<a id="a39b52087d31b2bee046af1dfd9a27db0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a39b52087d31b2bee046af1dfd9a27db0">&#9670;&nbsp;</a></span>writeCallback()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">size_t alexaClientSDK::avsCommon::utils::libcurlUtils::writeCallback </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>dataBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>blockSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numBlocks</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>dataStream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Write callback function used for CURLOPT_WRITEFUNCTION option in libcurl </p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a8c02f4058583acb4f014ed8dcf1bec08"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8c02f4058583acb4f014ed8dcf1bec08">&#9670;&nbsp;</a></span>CAPATH_CONFIG_KEY</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::CAPATH_CONFIG_KEY = &quot;CURLOPT_CAPATH&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Key for looking up a configuration value for <code>CURLOPT_CAPATH</code>. </p>

</div>
</div>
<a id="a809c291805fb165e687d4f65a3b922d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a809c291805fb165e687d4f65a3b922d6">&#9670;&nbsp;</a></span>INTERFACE_CONFIG_KEY</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::INTERFACE_CONFIG_KEY = &quot;CURLOPT_INTERFACE&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Key for looking up a configuration value for <code>CURLOPT_INTERFACE</code>. </p>

</div>
</div>
<a id="a8232ee401bb034d90e92f628ce333cf3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8232ee401bb034d90e92f628ce333cf3">&#9670;&nbsp;</a></span>INVALID_RESPONSE_CODE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr long alexaClientSDK::avsCommon::utils::libcurlUtils::INVALID_RESPONSE_CODE = -1L</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7fbbe720b79720306074ac8acb274883"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7fbbe720b79720306074ac8acb274883">&#9670;&nbsp;</a></span>JSON_MIME_TYPE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::utils::libcurlUtils::JSON_MIME_TYPE = &quot;application/json&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>MIME Content-Type for JSON data. </p>

</div>
</div>
<a id="a08b1ec8716b9c61f15790c03308a0d9c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a08b1ec8716b9c61f15790c03308a0d9c">&#9670;&nbsp;</a></span>LIBCURLUTILS_CONFIG_KEY <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::LIBCURLUTILS_CONFIG_KEY = &quot;libcurlUtils&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Key for looking up the <code>LibCurlUtil</code> <code>ConfigurationNode</code>. </p>

</div>
</div>
<a id="a08b1ec8716b9c61f15790c03308a0d9c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a08b1ec8716b9c61f15790c03308a0d9c">&#9670;&nbsp;</a></span>LIBCURLUTILS_CONFIG_KEY <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::LIBCURLUTILS_CONFIG_KEY = &quot;libcurlUtils&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Key for looking up the <code>LibCurlUtil</code> <code>ConfigurationNode</code>. </p>

</div>
</div>
<a id="a3ca3604189ed467fad1ee766125257b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ca3604189ed467fad1ee766125257b3">&#9670;&nbsp;</a></span>MAX_GET_BODY_WAIT</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::chrono::minutes alexaClientSDK::avsCommon::utils::libcurlUtils::MAX_GET_BODY_WAIT {1}</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Timeout to wait for a call to get body after getContent was called. </p>

</div>
</div>
<a id="aa144178293557a48cec87fd8a1eecfb1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa144178293557a48cec87fd8a1eecfb1">&#9670;&nbsp;</a></span>MAX_GET_HEADER_WAIT</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::chrono::minutes alexaClientSDK::avsCommon::utils::libcurlUtils::MAX_GET_HEADER_WAIT {5}</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Timeout to wait for get header to complete. </p>

</div>
</div>
<a id="ac61ca68afbad2308882b6206dfa1cb9b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac61ca68afbad2308882b6206dfa1cb9b">&#9670;&nbsp;</a></span>OCTET_MIME_TYPE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::utils::libcurlUtils::OCTET_MIME_TYPE = &quot;application/octet-stream&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>MIME Content-Type for octet stream data. </p>

</div>
</div>
<a id="aec2416d5a1025b96be723531fb5d92e8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aec2416d5a1025b96be723531fb5d92e8">&#9670;&nbsp;</a></span>TIMEOUT_CONNECTION</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const auto alexaClientSDK::avsCommon::utils::libcurlUtils::TIMEOUT_CONNECTION = std::chrono::seconds(30)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Timeout for curl connection. </p>

</div>
</div>
<a id="a582c6c6e07d6472ad6164f369bfc5745"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a582c6c6e07d6472ad6164f369bfc5745">&#9670;&nbsp;</a></span>TIMEOUT_FOR_BLOCKING_WRITE</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::chrono::milliseconds alexaClientSDK::avsCommon::utils::libcurlUtils::TIMEOUT_FOR_BLOCKING_WRITE = std::chrono::milliseconds(100)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">The timeout for a blocking write call to an <code>AttachmentWriter</code>. This value may be increased to decrease wakeups but may also increase latency. </p>

</div>
</div>
<a id="a5b622fcccbae1b42feafde78346af7d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5b622fcccbae1b42feafde78346af7d2">&#9670;&nbsp;</a></span>VERIFY_HOSTS_AND_PEERS_CONFIG_KEY</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::avsCommon::utils::libcurlUtils::VERIFY_HOSTS_AND_PEERS_CONFIG_KEY = &quot;verifyHostsAndPeers&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Key for looking up a configuration value for verifying hosts and peers. </p>

</div>
</div>
<a id="aae322c113e9b928d6af66474f5a281e2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aae322c113e9b928d6af66474f5a281e2">&#9670;&nbsp;</a></span>WAIT_FOR_ACTIVITY_TIMEOUT</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::chrono::milliseconds alexaClientSDK::avsCommon::utils::libcurlUtils::WAIT_FOR_ACTIVITY_TIMEOUT {100}</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Timeout for polling loops that check activities running on separate threads. </p>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
